using MediatR;
using Modules.Library.Application.Gateways;
using Modules.Library.Domain.Entities.MediaContent.Items.Anime;

namespace Modules.Library.Application.Commands.Anime.Episode.Properties.Genre;

public class DeleteGenreCommand : IRequest<Unit>
{
    public Guid TitleId { get; set; }
    public Guid SeasonId { get; set; }
    public Guid EpisodeId { get; set; }
    public Guid GenreId { get; set; }
}

public class DeleteGenreCommandHandler(IAnimeTitleGateway titleGateway) : IRequestHandler<DeleteGenreCommand, Unit>
{
    public async Task<Unit> Handle(DeleteGenreCommand request, CancellationToken cancellationToken)
    {
        var title = await titleGateway.GetById(request.TitleId);
        var season = title.Items.OfType<AnimeSeason>().FirstOrDefault(q => q.Id == request.SeasonId) ??
            throw new Exception("Season not found");
        var episode = season.Episodes.FirstOrDefault(q => q.Id == request.EpisodeId) ??
            throw new Exception("Episode not found");
        episode.CommonProperties.RemoveGenre(request.GenreId);
        await titleGateway.Update(title);
        return Unit.Value;
    }
}